<?php

require_once( dirname(__FILE__).'/base/basetrapmatcher.php' );

/**
 * Autogenerated class TrapMatcher_Model
 *
 * @todo: documentation
 */
class TrapMatcher_Model extends BaseTrapMatcher_Model {
	public static function upload_matcher($oid, $handler_id, $n = null)
	{
		$db = Database::instance('trapper');
		if ($n) {
			return $db->query('UPDATE matches SET oid='.$db->escape($oid).', handler_id='.$db->escape($handler_id).' WHERE n = '.$db->escape($n));
		} else {
			return $db->query('INSERT INTO matches(oid, handler_id) values ('.$db->escape($oid).', '.$db->escape($handler_id).')');
		}
	}

	public static function delete_matcher($n)
	{
		$db = Database::instance('trapper');
		return $db->query('DELETE FROM matches WHERE n = '.$db->escape($n));
	}

	public static function move_matcher($n, $direction)
	{
		
		$db = Database::instance('trapper');
		/* counter-intuitive: "up" in the match chain means "down" in the numerical sense - up decreases n, down increases n */
		$res = $db->query('SELECT '.($direction == 'down'?'MIN':'MAX').'(n) as max FROM matches WHERE n '.($direction == 'down'?'>':'<').' '.$db->escape($n));
		if (count($res) != 1) /* it's not an error if there are no matchers in this direction */
			return true;
		$res = $res->result_array(false);
		$other = $res[0]['max'];
		/* crazy query from traped
		 * mysql is broken - http://stackoverflow.com/questions/11207574 - and this trick avoids
		 * violating the unique constraint on n
		 */
		$n = $db->escape($n);
		$other = $db->escape($other);
		return $db->query("UPDATE matches AS a JOIN matches AS b ON (a.n = $n AND b.n = $other) JOIN matches AS c ON (c.n = a.n) ".
			"SET a.n = -a.n, b.n = $n, c.n = $other");
	}
}
